/* Copyright (c) 2006,2007,2008,2009 Polybus Systems Corp., Westford, MA, USA  */

/* All rights reserved. */

/* Redistribution and use in source and binary forms, with or without modification, */
/* are permitted provided that the following conditions are met: */

/* * Redistributions of source code must retain the above copyright notice, this */
/* list of conditions and the following disclaimer. */
/* * Redistributions in binary form must reproduce the above copyright notice, */
/* this list of conditions and the following disclaimer in the documentation */
/* and/or other materials provided with the distribution. */
/* * Neither the name of the Polybus Systems Corp nor the names of its contributors */
/* may be used to endorse or promote products derived from this software */
/* without specific prior written permission. */

/* THIS SOFTWARE IS PROVIDED BY POLYBUS AND CONTRIBUTORS ''AS IS'' AND ANY */
/* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE */
/* DISCLAIMED. IN NO EVENT SHALL POLYBUS OR CONTRIBUTORS BE LIABLE FOR ANY */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES */
/* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON */
/* ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT */
/* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS */
/* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

#include "sys_basher.h"


SInt32 intSInt64Test(void *base,SInt64 limit,SInt32 num,SInt32 num_threads,SInt32 firsttime,
		     SInt64 exp[32][NUM_FP_TESTS],result rslt[NUM_FP_TESTS][MAX_SIZES],SInt32 vnum,SInt64 time_scale[MAX_SIZES][NUM_FP_TESTS])
{
  SInt64 i,j,length,max;
  SInt32 num_sizes,errors=0,tnum;
  SInt64 acc;
  double bwidth[64][8];
  SInt64 got[64][8];
  SInt64 *fdata;
  char string[1024],xstring[1024];
  char *test_names[] = {
    "Add RR",
    "Add MR",
    "Mpy RR",
    "Mpy MR",
    "Div RR",
    "Div MR",
    "SofP MRR",
    "SofP MMR",
    0L};
  char *results[16];
  static char *flops="OPS";
  SInt64 src[] = {0x3FE278E2EF9D6B9ELL,
		  0x3FE278E2EF9D6B9ELL,
		  0xBFE278E2EF9D6B9DLL,
		  0xBFE278E2EF9D6B9DLL,
		  0x3E06C45A0A881B87LL,
		  0x3E06C45A0A881B87LL,
		  0x41D67D1AD7C067B1LL,
		  0x41D67D1AD7C067B1LL};

		     

  fdata = (SInt64 *)src;

  max = limit & 0xFFFFFFFFFFFF0000LL;
  if(max > 0x20000000LL) max = 0x20000000LL;
  max /= sizeof(SInt64);
  sprintf(string,"\nThread %ld of %ld: Running 64 Bit Integer Tests\n",(long)vnum,(long)num_threads);
  printTranscript(string,TRUE);
  length = 0x400L;
  num_sizes = 0;
  while(length < max)
    {
      acc = 0;
      //      len = length;
      //      iscale(string,"B",len);
      //      sprintf(xstring,"\tArray Size: %s\n",string);
      //      printTranscript(xstring,FALSE);
      tnum = 0;

      fillSInt64Mem(base,max,fdata,4L);

      got[num_sizes][tnum] = rrSInt64Sum(max,length,fdata,&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt64(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 64 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mrSInt64Sum(base,max,length,fdata,&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt64(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 64 %s",test_names[tnum]);
      tnum++;
 
      fillSInt64Mem(base,max,&fdata[4],4L);

      got[num_sizes][tnum] = rrSInt64Mpy(max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt64(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 64 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mrSInt64Mpy(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt64(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 64 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = rrSInt64Div(max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt64(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 64 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mrSInt64Div(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt64(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 64 %s",test_names[tnum]);
      tnum++;

      fillSInt64Mem(base,max,&fdata[4],1L);
      got[num_sizes][tnum] = mrrSInt64SumProd(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt64(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 64 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mmrSInt64SumProd(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt64(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 64 %s",test_names[tnum]);

      num_sizes++;
      length = length << 2;
    }

  length = 0x400L;
  errors = 0;
  sprintf(xstring,"\nThread %ld of %ld: 64 Bit Integer\n",(long)vnum,(long)num_threads);
  printTranscript(xstring,FALSE);
  displayTitles("Array Size",test_names,8L);
  for(i=0;i<8;i++) results[i] = flops;
  displayTitles("",results,8L);
  for(i=0;i<num_sizes;i++)
    {
      iscale(string,"B",length);
      displayLine(string,"/S",bwidth[i],8L);
      length = length << 2;
    }
  printTranscript("\n",FALSE);
  if(firsttime)
    {
      for(i=0;i<num_sizes;i++)
	{
	  for(j=0;j<NUM_FP_TESTS;j++)
	    {
	      exp[i][j] = got[i][j];
	    }
	}
    }
  else
    {
      length = 0x400L;
      for(i=0;i<NUM_FP_TESTS;i++) results[i] = "PASS/FAIL";
      displayTitles("Array Size",test_names,8L);
      displayTitles("",results,8L);
      for(i=0;i<num_sizes;i++)
	{
	  iscale(string,"B",length);
	  errors += displaySInt64PassFail(string,got[i],exp[i],NUM_FP_TESTS);
	  length = length << 2;
	}
    }


  if(errors == 0)
    { 
      sprintf(string,"PASSED\tThread %ld of %ld: 64 Bit Integer Tests\n",(long)vnum,(long)num_threads);
      printTranscript(string,TRUE);
      return(1L);
    }
  else
    {
      sprintf(string,"FAILED\tThread %ld of %ld: 64 Bit Integer Tests\n",(long)vnum,(long)num_threads);
      printTranscript(string,TRUE);
      return(0L);
    }

}


void fillSInt64Mem(SInt64 * base,SInt64 max,SInt64 ivalue[],SInt32 words)
{
  SInt64 *indx;
  SInt64 i,j;

  indx = base;

  for(i=0;i<max;i+=words)
    {
      for(j=0;j<words;j++)
	{
	  *indx++ = ivalue[j];
	}
    }
}
SInt64 rrSInt64Sum(SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt64 acc,w,x,y,z;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);


  while(!done)
    {
      acc = 0;
      w = fdata[0];
      x = fdata[1];
      y = fdata[2];
      z = fdata[3];
      start = getTime();

      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      for(j=0;j<length;j+=4)
		{
		  w += x;
		  x += y;
		  y += z;
		  x += w;
		}
	    }
	}
      end = getTime();
      acc = w + x + y +z;
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}
      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }
  ops = scale;
  ops *= loops;
  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt64 mrSInt64Sum(SInt64 * base,SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt64 acc,w,x,y,z,*indx;;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  while(!done)
    {
      w = 0;
      x = 0;
      y = 0;
      z = 0;
      acc = 0;
      start = getTime();

      for(k=0;k<scale;k++)
	{

	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=4)
		{
		  w += *indx++;
		  x += *indx++;
		  y += *indx++;
		  x += *indx++;
		}
	    }
	}
      end = getTime();
      acc = w + x + y +z;
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt64 rrSInt64Mpy(SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt64 acc=0,x=0,y=0;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  while(!done)
    {
      start = getTime();
      acc = 0;
      x = 1234L;
      y = -5678L;


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      for(j=0;j<length;j+=4)
		{
		  x *= fdata[0];
		  y *= fdata[1];
		  x *= fdata[2];
		  y *= fdata[3];
		}
	    }
	}
      end = getTime();
      acc = x + y;
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
    }

  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt64 mrSInt64Mpy(SInt64 * base,SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  double start=0,end=0,usecs=0,ops=0;
  SInt64 acc,x,y,*indx;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;
 
  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);


  while(!done)
    {
      acc = 0;
      x = 1234567;
      y = -34546;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=4)
		{
		  x *= *indx++;
		  y *= *indx++;
		  x *= *indx++;
		  y *= *indx++;
		}
	    }
	}
      end = getTime();
      acc = x + y;
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt64 rrSInt64Div(SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt64 acc=0,x=0,y=0;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  while(!done)
    {
      acc = 0;
      x = 0x11111111111111LL;
      y = 0xABCDEF01234567LL;

      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      for(j=0;j<length;j+=4)
		{
		  x /= fdata[0];
		  y /= fdata[1];
		  x /= fdata[2];
		  y /= fdata[3];
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt64 mrSInt64Div(SInt64 * base,SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  double start=0,end=0,usecs=0,ops=0;
  SInt64 acc,x,y,*indx;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);
  acc = 1.0;

  while(!done)
    {
      acc = 0;
      x = 0x11111111111111LL;
      y = 0xABCDEF01234567LL;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=4)
		{
		  x /= *indx++;
		  y /= *indx++;
		  x /= *indx++;
		  y /= *indx++;
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt64 mrrSInt64SumProd(SInt64 * base,SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt64 acc,sx,sy,x,y,*indx;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  acc = 0;

  while(!done)
    {
      acc = 0;
      x = 0;
      y = 0;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  indx = base;
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=8)
		{
		  sx = *indx++;
		  sx *= fdata[0];
		  x += sx;
		  sy = *indx++;
		  sy *= fdata[0];
		  y += sy;
		  sx = fdata[0];
		  sx *= *indx++;
		  x += sx;
		  sy = fdata[0];
		  sy *= *indx++;
		  y += sy;
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt64 mmrSInt64SumProd(SInt64 * base,SInt64 max,SInt64 length,SInt64 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  double start=0,end=0,usecs=0,ops=0;
  SInt64 acc,x,y,sx,sy,*indx=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;
 
  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  acc = 0;

  while(!done)
    {
      acc = 0;
      x = 0;
      y = 0;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  indx = base;
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=8)
		{
		  sx = *indx++;
		  sx *= *indx++;
		  x += sx;
		  sy = *indx++;
		  sy *= *indx++;
		  y += sy;
		  sx = *indx++;
		  sx *= *indx++;
		  x += sx;
		  sy = *indx++;
		  sy *= *indx++;
		  y += sy;
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt32 intLongTest(void *base,SInt64 limit,SInt32 num,SInt32 num_threads,SInt32 firsttime,
		   SInt32 exp[32][NUM_FP_TESTS],result rslt[NUM_FP_TESTS][MAX_SIZES],SInt32 vnum,SInt64 time_scale[MAX_SIZES][NUM_FP_TESTS])
{
  SInt64 i,j,length,max;
  SInt32 num_sizes,errors=0,tnum;
  SInt32 len;
  double bwidth[64][8];
  SInt32 got[64][8];
  SInt32 *fdata;
  char string[1024];
  char *test_names[] = {
    "Add RR",
    "Add MR",
    "Mpy RR",
    "Mpy MR",
    "Div RR",
    "Div MR",
    "SofP MRR",
    "SofP MMR",
    0L};
  char *results[16];
  static char *flops="OPS";

  UInt32 src[] = {0x40490FDBL,
		  0x40490FDBL,
		  0xC0490FD7L,
		  0xC0490FD7L,
		  0x402DF854L,
		  0x402DF854L,
		  0x3EBC5AB2L,
		  0x3EBC5AB2L,
		  0x402DF854L,
		  0x3EBC5AB2L,
		  0x402DF854L,
		  0x3EBC5AB2L
  };

  max = limit & 0xFFFFFFFFFFFF0000LL;
  if(max > 0x40000000LL) max = 0x40000000LL;
  max /= sizeof(SInt32);
  sprintf(string,"\nThread %ld of %ld: Running 32 bit Integer Tests\n",(long)vnum,(long)num_threads);
  printTranscript(string,TRUE);
  length = 0x400L;
  num_sizes = 0;
  fdata = (SInt32 *)src;

  for(i=0;i<64;i++)
    {
      for(j=0;j<8;j++)
	{
	  bwidth[i][j] = 0;
	}
    }

  while(length < max)
    {
      len = length;
      //      iscale(string,"B",len);
      //      sprintf(xstring,"\tArray Size: %s\n",string);
      //      printTranscript(xstring,FALSE);
      tnum = 0;


      fillLongMem(base,max,fdata,4l);
      got[num_sizes][tnum] = rrLongSum(max,length,fdata,&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt32(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 32 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mrLongSum(base,max,length,fdata,&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt32(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 32 %s",test_names[tnum]);
      tnum++;
 
      fillLongMem(base,max,&fdata[4],4l);

      got[num_sizes][tnum] = rrLongMpy(max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt32(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 32 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mrLongMpy(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt32(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 32 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = rrLongDiv(max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt32(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 32 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mrLongDiv(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt32(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 32 %s",test_names[tnum]);
      tnum++;

      fillLongMem(base,max,&fdata[4],1L);
      got[num_sizes][tnum] = mrrLongSumProd(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt32(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 32 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mmrLongSumProd(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt32(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 32 %s",test_names[tnum]);

      num_sizes++;
      length = length << 2;
    }

  length = 0x400L;
  errors = 0;
  sprintf(string,"\nThread %ld of %ld: 32 Bit Integer Performance\n",(long)vnum,(long)num_threads);
  printTranscript(string,FALSE);
  displayTitles("Array Size",test_names,8L);
  for(i=0;i<8;i++) results[i] = flops;
  displayTitles("",results,8L);
  for(i=0;i<num_sizes;i++) 
    {
      iscale(string,"B",length);
      displayLine(string,"/S",bwidth[i],8L);
      //      displayHexLong("results","",got[i],8L);
      length = length << 2;
    }

  errors = 0;
  length = 0x400L;
  for(i=0;i<8;i++) results[i] = "PASS/FAIL";  
  printTranscript("\n",TRUE);

  if(firsttime)
    {
      for(i=0;i<num_sizes;i++)
	{
	  for(j=0;j<NUM_FP_TESTS;j++)
	    {
	      exp[i][j] = got[i][j];
	    }
	}
    }
  else
    {
      length = 0x400L;
      for(i=0;i<NUM_FP_TESTS;i++) results[i] = "PASS/FAIL";
      displayTitles("Array Size",test_names,8L);
      displayTitles("",results,8L);
      for(i=0;i<num_sizes;i++)
	{
	  iscale(string,"B",length);
	  errors += displayLongPassFail(string,got[i],exp[i],NUM_FP_TESTS);
	  length = length << 2;
	}
    }

  
  if(errors == 0)
    {
      sprintf(string,"PASSED\tThread %ld of %ld: 32 Bit Integer Tests\n",(long)vnum,(long)num_threads);
      printTranscript(string,TRUE);
      return(1L);
    }
  else
    {
      sprintf(string,"FAILED\tThread %ld of %ld: 32 Bit Integer Tests\n",(long)vnum,(long)num_threads);
      printTranscript(string,TRUE);
      return(0L);
    }

}


void fillLongMem(SInt32 *base,SInt64 max,SInt32 ivalue[],SInt32 words)
{
  SInt32 *indx;
  SInt64 i,j;

  indx = base;
  for(i=0;i<max;i+=words)
    {
      for(j=0;j<words;j++)
	{
	  *indx++ = ivalue[j];
	}
    }
}
SInt32 rrLongSum(SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt32 acc,w,x,y,z;
  double start,end,usecs=0,ops;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);


  while(!done)
    {
      w = fdata[0];
      x = fdata[1];
      y = fdata[2];
      z = fdata[3];
      acc = 0;
      start = getTime();

      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      for(j=0;j<length;j+=4)
		{
		  w += x;
		  x += y;
		  y += z;
		  x += w;
		}
	    }
	}
      end = getTime();
      acc = w + x + y +z;
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }
  ops = scale;
  ops *= loops;
  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt32 mrLongSum(SInt32 * base,SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt32 acc,w,x,y,z,*indx;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  while(!done)
    {
      w = 0;
      x = 0;
      y = 0;
      z = 0;
      acc = 0;
      start = getTime();

      for(k=0;k<scale;k++)
	{

	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=4)
		{
		  w += *indx++;
		  x += *indx++;
		  y += *indx++;
		  x += *indx++;
		}
	    }
	}
      end = getTime();
      acc = w + x + y +z;
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt32 rrLongMpy(SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt32 acc,x,y;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  while(!done)
    {
      acc = 0;
      x = -3456L;
      y = x * x;

      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      for(j=0;j<length;j+=4)
		{
		  x *= fdata[0];
		  y *= fdata[1];
		  x *= fdata[2];
		  y *= fdata[3];
		}
	    }
	}
      end = getTime();
      acc = x + y;
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt32 mrLongMpy(SInt32 *base,SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt32 acc,x,y,*indx;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  while(!done)
    {
      acc = 0;
      x = -33333L;
      y = x * x;

      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=4)
		{
		  x *= *indx++;
		  y *= *indx++;
		  x *= *indx++;
		  y *= *indx++;
		}
	    }
	}
      end = getTime();
      acc = x + y;
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt32 rrLongDiv(SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt32 acc,x,y;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);
  acc = 1.0;

  while(!done)
    {
      acc = 0;
      x = 12345677;
      y = 0x89ABCDEF;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      for(j=0;j<length;j+=4)
		{
		  x /= fdata[0];
		  y /= fdata[1];
		  x /= fdata[2];
		  y /= fdata[3];
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt32 mrLongDiv(SInt32 * base,SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;
  SInt32 acc,x,y,*indx;
  double start=0,end=0,usecs=0,ops=0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);
  acc = 1.0;

  while(!done)
    {
      acc = 0;
      x = 12345677;
      y = 0x89ABCDEF;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=4)
		{
		  x /= *indx++;
		  y /= *indx++;
		  x /= *indx++;
		  y /= *indx++;
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt32 mrrLongSumProd(SInt32 * base,SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt32 acc,x,y,sx,sy,*indx;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  acc = 0;

  while(!done)
    {
      acc = 0;
      x = 0;
      y = 0;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  indx = base;
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=8)
		{
		  sx = *indx++;
		  sx *= fdata[0];
		  x += sx;
		  sy = fdata[0];
		  sy *= *indx++;
		  y += sy;
		  sx = *indx++;
		  sx *= fdata[0];
		  x += sx;
		  sy = fdata[0];
		  sy *= *indx++;
		  y += sy;
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt32 mmrLongSumProd(SInt32 * base,SInt64 max,SInt64 length,SInt32 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt32 acc,x,y,sx,sy,*indx;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  acc = 0;

  while(!done)
    {
      acc = 0;
      x = 0;
      y = 0;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  indx = base;
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=8)
		{
		  sx = *indx++;
		  sx *= *indx++;
		  x += sx;
		  sy = *indx++;
		  sy *= *indx++;
		  y += sy;
		  sx = *indx++;
		  sx *= *indx++;
		  x += sx;
		  sy = *indx++;
		  sy *= *indx++;
		  y += sy;
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}



SInt32 intSInt16Test(void *base,SInt64 limit,SInt32 num,SInt32 num_threads,SInt32 firsttime,
		     SInt16 exp[32][NUM_FP_TESTS],result rslt[NUM_FP_TESTS][MAX_SIZES],SInt32 vnum,SInt64 time_scale[MAX_SIZES][NUM_FP_TESTS])
{
  SInt64 i,j,length,max;
  SInt32 num_sizes,errors=0,tnum;
  SInt64 acc;
  double bwidth[64][8];
  SInt16 got[64][8];
  SInt16 *fdata;
  char string[1024],xstring[1024];
  char *test_names[] = {
    "Add RR",
    "Add MR",
    "Mpy RR",
    "Mpy MR",
    "Div RR",
    "Div MR",
    "SofP MRR",
    "SofP MMR",
    0L};
  char *results[16];
  static char *flops="OPS";
  UInt16 src[] = {0x0123,
		  0x4567,
		  0x89AB,
		  0xCDEF,
		  0xFEDC,
		  0xBA98,
		  0x7654,
		  0x3210,
		  0x1234,
		  0x4568,
		  0x9ABC,
		  0xDEF0,
		  0x0FED,
		  0xCBA9,
		  0x8765,
		  0x4321,
		  0x0123,
		  0x4567,
		  0x89AB,
		  0xCDEF,
		  0xFEDC,
		  0xBA98,
		  0x7654,
		  0x3210,
		  0x1234,
		  0x4568,
		  0x9ABC,
		  0xDEF0,
		  0x0FED,
		  0xCBA9,
		  0x8765,
		  0x4321};

  fdata = (SInt16 *)src;

  max = limit & 0xFFFFFFFFFFFF0000LL;
  if(max > 0x20000000LL) max = 0x20000000LL;
  max /= sizeof(SInt16);
  sprintf(string,"\nThread %ld of %ld: Running 16 Bit Integer Tests\n",(long)vnum,(long)num_threads);
  printTranscript(string,TRUE);
  length = 0x400L;
  num_sizes = 0;
  while(length < max)
    {
      acc = 0;
      //      len = length;
      //      iscale(string,"B",len);
      //      sprintf(xstring,"\tArray Size: %s\n",string);
      //      printTranscript(xstring,FALSE);
      tnum = 0;

      fillSInt16Mem(base,max,fdata,4L);

      got[num_sizes][tnum] = rrSInt16Sum(max,length,fdata,&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt16(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 16 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mrSInt16Sum(base,max,length,fdata,&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt16(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 16 %s",test_names[tnum]);
      tnum++;
 
      fillSInt16Mem(base,max,&fdata[4],4L);

      got[num_sizes][tnum] = rrSInt16Mpy(max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt16(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 16 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mrSInt16Mpy(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt16(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 16 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = rrSInt16Div(max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt16(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 16 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mrSInt16Div(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt16(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 16 %s",test_names[tnum]);
      tnum++;

      fillSInt16Mem(base,max,&fdata[4],1L);
      got[num_sizes][tnum] = mrrSInt16SumProd(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt16(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 16 %s",test_names[tnum]);
      tnum++;

      got[num_sizes][tnum] = mmrSInt16SumProd(base,max,length,&fdata[4],&bwidth[num_sizes][tnum],&rslt[tnum][num_sizes],&time_scale[num_sizes][tnum]);
      chkSInt16(firsttime,exp[num_sizes][tnum],got[num_sizes][tnum],&rslt[tnum][num_sizes]);
      rslt[tnum][num_sizes].size = length;
      sprintf(rslt[tnum][num_sizes].name,"Signed Int 16 %s",test_names[tnum]);

      num_sizes++;
      length = length << 2;
    }

  length = 0x400L;
  errors = 0;
  sprintf(xstring,"\nThread %ld of %ld: 16 Bit Integer\n",(long)vnum,(long)num_threads);
  printTranscript(xstring,FALSE);
  displayTitles("Array Size",test_names,8L);
  for(i=0;i<8;i++) results[i] = flops;
  displayTitles("",results,8L);
  for(i=0;i<num_sizes;i++)
    {
      iscale(string,"B",length);
      displayLine(string,"/S",bwidth[i],8L);
      length = length << 2;
    }
  printTranscript("\n",FALSE);
  if(firsttime)
    {
      for(i=0;i<num_sizes;i++)
	{
	  for(j=0;j<NUM_FP_TESTS;j++)
	    {
	      exp[i][j] = got[i][j];
	    }
	}
    }
  else
    {
      length = 0x400L;
      for(i=0;i<NUM_FP_TESTS;i++) results[i] = "PASS/FAIL";
      displayTitles("Array Size",test_names,8L);
      displayTitles("",results,8L);
      for(i=0;i<num_sizes;i++)
	{
	  iscale(string,"B",length);
	  errors += displaySInt16PassFail(string,got[i],exp[i],NUM_FP_TESTS);
	  length = length << 2;
	}
    }


  if(errors == 0)
    { 
      sprintf(string,"PASSED\tThread %ld of %ld: 16 Bit Integer Tests\n",(long)vnum,(long)num_threads);
      printTranscript(string,TRUE);
      return(1L);
    }
  else
    {
      sprintf(string,"FAILED\tThread %ld of %ld: 16 Bit Integer Tests\n",(long)vnum,(long)num_threads);
      printTranscript(string,TRUE);
      return(0L);
    }

}




void fillSInt16Mem(SInt16 * base,SInt64 max,SInt16 ivalue[],SInt32 words)
{
  SInt16 *indx;
  SInt64 i,j;

  indx = base;

  for(i=0;i<max;i+=words)
    {
      for(j=0;j<words;j++)
	{
	  *indx++ = ivalue[j];
	}
    }
}
SInt16 rrSInt16Sum(SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt16 acc,w,x,y,z;
  double start,end,usecs=0,ops;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  while(!done)
    {
      w = fdata[0];
      x = fdata[1];
      y = fdata[2];
      z = fdata[3];
      acc = 0;
      start = getTime();
      for(k=0;k<scale;k++)
	{

	  for(i=0;i<loops;i++)
	    {
	      for(j=0;j<length;j+=4)
		{
		  w += x;
		  x += y;
		  y += z;
		  x += w;
		}
	    }
	}
	
      end = getTime();
      acc = w + x + y +z;
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }
  ops = scale;
  ops *= loops;
  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt16 mrSInt16Sum(SInt16 * base,SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt16 acc,w,x,y,z,*indx;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  while(!done)
    {
      w = 0;
      x = 0;
      y = 0;
      z = 0;
      acc = 0;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=4)
		{
		  w += *indx++;
		  x += *indx++;
		  y += *indx++;
		  x += *indx++;
		}
	    }
	}
      end = getTime();
      acc = w + x + y +z;
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt16 rrSInt16Mpy(SInt16 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt16 acc=0,x=0,y=0;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);


  while(!done)
    {
      acc = 0;
      x = -1234;
      y = 4567;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      for(j=0;j<length;j+=4)
		{
		  x *= fdata[0];
		  y *= fdata[1];
		  x *= fdata[2];
		  y *= fdata[3];
		}
	    }
	}
      end = getTime();
      acc = x + y;

      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt16 mrSInt16Mpy(SInt16 * base,SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  double start=0,end=0,usecs=0,ops=0;
  SInt16 acc,x,y,*indx;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);


  while(!done)
    {
      acc = 0;
      x = 4444L;
      y = -3333L;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=4)
		{
		  x *= *indx++;
		  y *= *indx++;
		  x *= *indx++;
		  y *= *indx++;
		}
	    }
	}
      end = getTime();
      acc = x + y;
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt16 rrSInt16Div(SInt16 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt16 acc=0,x=0,y=0;
  double start=0,end=0,usecs=0,ops=0;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);


  while(!done)
    {
      acc = 0;
      x = 0x1111;
      y = 0xABCD;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      for(j=0;j<length;j+=4)
		{
		  x /= fdata[0];
		  y /= fdata[1];
		  x /= fdata[2];
		  y /= fdata[3];
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt16 mrSInt16Div(SInt16 * base,SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  double start=0,end=0,usecs=0,ops=0;
  SInt16 x,y,*indx,acc;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);
  acc = 1.0;

  while(!done)
    {
      acc = 0;
      x = 0x1111;
      y = 0xABCD;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=4)
		{
		  x /= *indx++;
		  y /= *indx++;
		  x /= *indx++;
		  y /= *indx++;
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt16 mrrSInt16SumProd(SInt16 * base,SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  SInt16 acc,sx,sy,x,y,*indx;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;
  double start=0,end=0,usecs=0,ops=0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  acc = 0;

  while(!done)
    {
      acc = 0;
      x = 0;
      y = 0;
      start = getTime();


      for(k=0;k<scale;k++)
	{
	  indx = base;

	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=8)
		{
		  sx = *indx++;
		  sx *= fdata[0];
		  x += sx;
		  sy = *indx++;
		  sy *= fdata[0];
		  y += sy;
		  sx = fdata[0];
		  sx *= *indx++;
		  x += sx;
		  sy = fdata[0];
		  sy *= *indx++;
		  y += sy;
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
      
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}

SInt16 mmrSInt16SumProd(SInt16 * base,SInt64 max,SInt64 length,SInt16 fdata[],double *bwidth,result *rslt,SInt64 *time_scale)
{
  double start=0,end=0,usecs=0,ops=0;
  SInt16 acc,x,y,sx,sy,*indx;
  SInt64 i,j,k,loops,scale=*time_scale;
  Boolean firstTime=0,done = 0;

  if(scale == 0)
    {
      scale = 1;
      firstTime = TRUE;
    }
  loops = numLoops(length);

  acc = 0;

  while(!done)
    {
      x = 0;
      y = 0;
      acc = 0;
      start = getTime();


      indx = base;
      for(k=0;k<scale;k++)
	{
	  for(i=0;i<loops;i++)
	    {
	      indx = base;
	      for(j=0;j<length;j+=8)
		{
		  sx = *indx++;
		  sx *= *indx++;
		  x += sx;
		  sy = *indx++;
		  sy *= *indx++;
		  y += sy;
		  sx = *indx++;
		  sx *= *indx++;
		  x += sx;
		  sy = *indx++;
		  sy *= *indx++;
		  y += sy;
		}
	    }
	}
      end = getTime();
      usecs = end - start;
      if(firstTime)
	{
	  scale = scale * 2LL;
	  *time_scale = scale;
	}

      done = !firstTime;
      if(usecs > 250000.0) firstTime = 0;
    }

  acc = x + y;
  ops = scale;
  ops *= loops;

  ops *= length;
  *bwidth = ops/usecs;
  updateBandwidth(*bwidth,usecs,ops,rslt);
  return(acc);
}
	
